package org.jboss.jtademo;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;

import javax.transaction.xa.XAResource;
import javax.transaction.xa.Xid;

public class PrintXAResource implements XAResource, Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = -3487338231918838538L;
	
	private int transactionTimeout = 0;

	public void commit(Xid xid, boolean onePhase) {
		System.out.println("\tcommit xid=" + xid + ", onePhase=" + onePhase);
	}

	public void end(Xid xid, int flags) {
		System.out.println("\tend xid=" + xid + ", flags=" + Util.convertTMFlags(flags));
	}

	public void forget(Xid xid) {
		System.out.println("\tforget xid=" + xid);
	}

	public int getTransactionTimeout() {
		System.out.println("\tgetTransactionTimeout");
		return transactionTimeout;
	}

	public boolean isSameRM(XAResource xares) {
		System.out.println("\tisSame");
		return this == xares;
	}

	public int prepare(Xid xid) {
		System.out.println("\tprepare xid=" + xid);
		return XA_OK;
	}

	public Xid[] recover(int flag) {
		System.out.println("\trecover flag=" + Util.convertTMFlags(flag));
		return new Xid[0];
	}

	public void rollback(Xid xid) {
		System.out.println("\trollback xid=" + xid);
	}

	public boolean setTransactionTimeout(int seconds) {
		System.out.println("\tsetTransactionTimeout seconds=" + seconds);
		this.transactionTimeout = seconds;
		return true;
	}

	public void start(Xid xid, int flags) {
		System.out.println("\tstart xid=" + xid + ", flags=" + Util.convertTMFlags(flags));
	}

	private void writeObject(ObjectOutputStream out) throws IOException {
		System.out.println("\tStore object");
	}

	private void readObject(ObjectInputStream in) throws IOException, ClassNotFoundException {
		System.out.println("\tRecover object");
	}

}
